/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Cafeteria サーバクラス
//        変更履歴
//			2005.12.19	新規作成	大賀俊彦
//
//
//
package jp.co.ntt.lms.lo.Cafeteria;

import java.rmi.RemoteException;
import java.util.Hashtable;
import java.util.Vector;

import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.lo.LoPropertyDef;
import jp.co.ntt.lms.lo.LoServer;
import jp.co.ntt.lms.lo.LoTop;
import jp.co.ntt.lms.xmo.MessageData;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * Cafeteria サーバクラスです。<BR>
 * 要求を受けたLOのメニューリストを作成して返します
 * RMIサーバとして動作するためRemoteインタフェースであるLoTopインタフェースを実装し、
 * 永続的な起動状態を確保するためjava.rmi.server.UnicastRemoteObjectクラスを継承します。
 */
public class CafeteriaLo extends LoServer
	implements LoTop, LoPropertyDef, CafeteriaLoTable
{
	//////////////////////////////////////////////////////////////////
	// メソッド名定義
	//////////////////////////////////////////////////////////////////
	/**
	 * コンストラクタです。
	 */
	public CafeteriaLo() throws LOException, RemoteException
	{
		// リモートオブジェクトをエクスポートする
		// java.rmi.server.UnicastRemoteObject の
		// 引数なしのコンストラクタを呼び出す
		super();
		// 教材構造ファイルをすべてロードします
		try
		{
			mobjMenuMakerIF = new CafeteriaLoMenuMaker();
			mobjLearnManagerIF = new CafeteriaLoLearnManager();
			mobjSetupIF = new CafeteriaLoSetup();
		}
		catch( Exception e )
		{
			throw new LOException( this.getClass().getName() + " :: ロード失敗 " );
		}
	}
	
	/**
	 * 教材一覧を返します
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと教材一覧
	 */
	public Vector getMaterialList( Hashtable htbParam )
	{
		DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
		DebugLog.write( this.getClass(), "     LaunchForget教材: getMaterialList Start", DebugLog.ROW );
		DebugLog.write( this.getClass(), "#########################################", DebugLog.ROW );
		return new Vector();
	}
	
	/**
	 * データ取得処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector getData(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objRet = objDataAccess.getData( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

	/**
	 * Loに登録されているメソッドを起動します。<br>
	 * 現在有効なメソッドは、{@link #getServerInfo()}だけです。
	 * @param methodName 起動するメソッド名称。<br>
	 * @param params パラメータ。
	 * @return 起動したメソッドから戻されたVector。
	 * @see #getServerInfo()
	 * @see #isExistLoginSession(Hashtable)
	 * @see jp.co.ntt.lms.lo.LoTop#execute(String, Hashtable)
	 */
	public Vector execute(String methodName, Hashtable params) {

		Vector returnValue = null;

		if (methodName.equals(INSERTASSIGNREQUEST)) {
			returnValue = insertAssignRequest(params);
		}
		else if (methodName.equals(SELECTASSIGNREQUEST)) {
			returnValue = selectAssignRequest(params);
		}
		else if (methodName.equals(DELETEASSIGNREQUEST)) {
			returnValue = deleteAssignRequest(params);
		}
		else if (methodName.equals(UPDATEASSIGNREQUEST)) {
			returnValue = updateAssignRequest(params);
		}
		else if (methodName.equals(SELECTCAFETERIALOLISTDATA)) {
			returnValue = selectCafeteriaLoListData(params);
		}
		else if (methodName.equals(INSERTCAFETERIALISTLO)) {
			returnValue = insertCafeteriaListLo(params);
		}
		else if (methodName.equals(SELECTCAFETERIALISTLO)) {
			returnValue = selectCafeteriaListLo(params);
		}
		else if (methodName.equals(DELETECAFETERIALISTLO)) {
			returnValue = deleteCafeteriaListLo(params);
		}
		else if (methodName.equals(UPDATECAFETERIALISTLO)) {
			returnValue = updateCafeteriaListLo(params);
		}
		else {
			returnValue = new Vector();
		}
		return returnValue;
	}


	/**
	 * AssignRequestデータ追加処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector insertAssignRequest(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objDataAccess.insertAssignRequest( htbParam );
		}
		catch(Exception le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}
	
	/**
	 * AssignRequestデータ取得処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector selectAssignRequest(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objRet = objDataAccess.selectAssignRequestData( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

	/**
	 * AssignRequest削除処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector deleteAssignRequest(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objDataAccess.deleteAssignRequest( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}
	/**
	 * AssignRequestデータ更新処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector updateAssignRequest(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objDataAccess.updateAssignRequest( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

	/**
	 * CafeteriaLoListDataデータ取得処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector selectCafeteriaLoListData(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objRet = objDataAccess.selectCafeteriaLoListData( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}
	
//CafeteriaListLo単独処理

	/**
	 * CafeteriaListLoデータ追加処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector insertCafeteriaListLo(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objDataAccess.insertCafeteriaListLo( htbParam );
		}
		catch(Exception le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}
	
	/**
	 * CafeteriaListLoデータ取得処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector selectCafeteriaListLo(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objRet = objDataAccess.selectCafeteriaListLo( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

	/**
	 * CafeteriaListLo削除処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector deleteCafeteriaListLo(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objDataAccess.deleteCafeteriaListLo( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}
	/**
	 * CafeteriaListLoデータ更新処理
	 * @param String
	 * @param Hashtable パラメータリスト
	 * @return Vector メッセージデータと実行結果データ
	 */
	public Vector updateCafeteriaListLo(Hashtable htbParam)
	{
		Vector vecRet     = new Vector();
		MessageData objMd = null;
		Object objRet     = null;
		try
		{
			CafeteriaLoDataAccess objDataAccess = new CafeteriaLoDataAccess();
			
			objDataAccess.updateCafeteriaListLo( htbParam );
		}
		catch(LOException le)
		{
			// メッセージデータオブジェクトが取得できない場合は
			// システムエラーメッセージオブジェクトを生成
			objMd = createSystemErrMessage(le.getMessage());
		}
		vecRet.add(objMd);
		vecRet.add(objRet);
		return vecRet;
	}

}
